﻿using Android.Bluetooth;
using Com.Asreader.P252b.Barcode;
using Com.Asreader.P252b.Device.Type;
using Com.Asreader.P252b.Rfid.Type;

namespace AsReaderP252BAndroidDemo.Platforms.Android
{
	public class AsReaderP252BDelegate
	{ 
        public delegate void OnStateChangedDelegate(AsReaderP252BConnectionState state);
        public OnStateChangedDelegate OnStateChanged;

        public delegate void OnReadTagDelegate(AsReaderP252BActionState p1, string p2, float p3, float p4, float p5);
        public OnReadTagDelegate OnReadTag;

        public delegate void OnReadBarcodeDelegate(AsReaderP252BBarcodeType p1, byte[] p2);
        public OnReadBarcodeDelegate OnReadBarcode;

        public delegate bool OnKeyEventDelegate(AsReaderP252BKeyState p1);
        public OnKeyEventDelegate OnKeyEvent;
         
        public delegate void OnActionChangedDelegate(AsReaderP252BActionState p1);
        public OnActionChangedDelegate OnActionChanged;

        public delegate void OnFoundDeviceFinishedDelegate();
        public OnFoundDeviceFinishedDelegate OnFoundDeviceFinished;

        public delegate void OnReceivedDeviceDelegate(BluetoothDevice p0);
        public OnReceivedDeviceDelegate OnReceivedDevice;
 

        static AsReaderP252BDelegate uniqueInstance;

        static readonly object locker = new object();

        public static AsReaderP252BDelegate sharedInstance()
        {
            if (uniqueInstance == null)
            {
                lock (locker)
                {
                    if (uniqueInstance == null)
                    {
                        uniqueInstance = new AsReaderP252BDelegate();
                    }
                }
            }
            return uniqueInstance;
        }
        public AsReaderP252BDelegate()
        {
        }
    }
}

