﻿using AsReaderP252BAndroidSDK;
using Com.Asreader.P252b;
using Com.Asreader.P252b.Rfid.Event;
using Com.Asreader.P252b.Rfid.Type;
using Com.Asreader.P252b.Device.Type;
using Com.Asreader.P252b.Barcode;
using Com.Asreader.P252b.Device;
using System.Collections;
using Com.Asreader.P252b.Rfid.Params;
using Com.Asreader.P252b.Device.BluetoothEvent;
using Android.Bluetooth;

namespace AsReaderP252BAndroidDemo.Platforms.Android
{
    public class AsReaderP252BMAUIManager
    {

        public class MyAsReaderBLEDeviceDelegate : Java.Lang.Object, IAsReaderP252BBluetoothDiscoveryEventListener
        {
            AsReaderP252BDelegate asReaderP252BDelegate = AsReaderP252BDelegate.sharedInstance();

            public void OnFoundDeviceFinished()
            {
                if (asReaderP252BDelegate.OnFoundDeviceFinished != null)
                {
                    asReaderP252BDelegate.OnFoundDeviceFinished();
                }
            }

            public void OnReceivedDevice(BluetoothDevice p0)
            {
                if (asReaderP252BDelegate.OnReceivedDevice != null)
                {
                    asReaderP252BDelegate.OnReceivedDevice(p0);
                }
            }
        }

        public class MyAsReaderDeviceDelegate : Java.Lang.Object, IAsReaderP252BEventListener
        {
            AsReaderP252BDelegate asReaderP252BDelegate = AsReaderP252BDelegate.sharedInstance();
            public MyAsReaderDeviceDelegate()
            {

            } 

            public void OnAccessResult(AsReaderP252B p0, AsReaderP252BResultCode p1, AsReaderP252BActionState p2, string p3, string p4, float p5, float p6, float p7)
            {
            }

            public void OnActionChanged(AsReaderP252B p0, AsReaderP252BActionState p1)
            {
                if (asReaderP252BDelegate.OnActionChanged != null)
                {
                    asReaderP252BDelegate.OnActionChanged(p1);
                }
            }

            public bool OnKeyEvent(AsReaderP252B p0, AsReaderP252BKeyState p1)
            {
                if (asReaderP252BDelegate.OnKeyEvent != null)
                { 
                    return asReaderP252BDelegate.OnKeyEvent(p1);
                }
                return false;
            }

            public bool OnModeKeyEvent(AsReaderP252B p0, AsReaderP252BKeyState p1)
            {
                return false;
            }

            public void OnReadBarcode(AsReaderP252B p0, AsReaderP252BBarcodeType p1, string p2)
            {
            }

            public void OnReadBarcodeData(AsReaderP252B p0, AsReaderP252BBarcodeType p1, byte[] p2)
            {
                if (asReaderP252BDelegate.OnReadBarcode != null)
                {
                    asReaderP252BDelegate.OnReadBarcode(p1, p2);
                }
            }

            public void OnReadHumidityTag(AsReaderP252B p0, AsReaderP252BActionState p1, string p2, float p3, float p4, float p5, float p6)
            {
            }

            public void OnReadTag(AsReaderP252B p0, AsReaderP252BActionState p1, string p2, float p3, float p4, float p5)
            {
                if (asReaderP252BDelegate.OnReadTag != null)
                {
                    asReaderP252BDelegate.OnReadTag(p1, p2, p3, p4, p5);
                }
            }

            public void OnReadTemperatureTag(AsReaderP252B p0, AsReaderP252BActionState p1, string p2, float p3, float p4, float p5, float p6)
            {
               
            }

            public void OnReceivedData(byte[] p0)
            { 
            }

            public void OnStateChanged(AsReaderP252B p0, AsReaderP252BConnectionState p1)
            {
                if (p1 == AsReaderP252BConnectionState.Connected)
                {
                    AsReaderP252BMAUIManager.sharedInstance().isConnect = true;
                    AsReaderP252BMAUIManager.sharedInstance().mReader.BarcodeTimeOut = 4;
                }
                else
                {
                    AsReaderP252BMAUIManager.sharedInstance().isConnect = false;
                }
                if (asReaderP252BDelegate.OnStateChanged != null)
                {
                    asReaderP252BDelegate.OnStateChanged(p1);
                }
            }
        }


        public AsReaderP252B mReader;
        public AsReaderP252BDevice mDevice;
        public AsReaderP252BDevice usbCdc;
        public AsReaderP252BDeviceBluetoothCdc deviceBluetoothCdc;

        private MyAsReaderDeviceDelegate myAsReaderDeviceDelegate;
        private MyAsReaderBLEDeviceDelegate myAsReaderBLEDeviceDelegate;
        private int max;
        public  bool isConnect;

        static AsReaderP252BMAUIManager uniqueInstance;
        static readonly object locker = new object();
        public static AsReaderP252BMAUIManager sharedInstance()
        {
            if (uniqueInstance == null)
            {
                lock (locker)
                {
                    if (uniqueInstance == null)
                    {
                        uniqueInstance = new AsReaderP252BMAUIManager();
                    }
                }
            }
            return uniqueInstance;
        }

        public AsReaderP252BMAUIManager()
        {
            isConnect = false;
            mReader = AsReaderP252BManager.Instance;
            myAsReaderDeviceDelegate = new MyAsReaderDeviceDelegate();
            mReader.SetEventListener(myAsReaderDeviceDelegate);
        }
        public void SetContext()
        {
            usbCdc = new AsReaderP252BDeviceUsbCdc(MainActivity.Instance);
            deviceBluetoothCdc = new AsReaderP252BDeviceBluetoothCdc(MainActivity.Instance);
            myAsReaderBLEDeviceDelegate = new MyAsReaderBLEDeviceDelegate();
            deviceBluetoothCdc.SetBluetoothDiscoveryEventListener(myAsReaderBLEDeviceDelegate);
        }
        public void ConnectDevice()
        {
            mDevice = AsReaderP252BManager.Instance.CurrentDevice;

            if (mDevice == null)
            {
                mDevice = usbCdc;
            }
            mReader.ConnectDevice(usbCdc);
        }

        public void DisconnectDevice()
        {
            if (mDevice != null)
            {
                mReader.DisconnectDevice();
            }
        }
        public void StartDiscovery()
        {
            deviceBluetoothCdc.StartDiscovery();
        }
        public void StopDiscovery()
        {
            deviceBluetoothCdc.StopDiscovery();
        }
        public void ConnectBluetoothDevice(string macAddress)
        {
            if (deviceBluetoothCdc != null)
            {
                mDevice = deviceBluetoothCdc;
                mDevice.Address = macAddress;
                mReader.ConnectDevice(mDevice);
            }
        }
        public int PowerGain
        {
            get
            {
                if (GetAsReaderStatus() == false)
                {
                    return 5;
                }
                return mReader.PowerGain;
            }
            set
            {
                if (GetAsReaderStatus() == false)
                {
                    return;
                }
                mReader.PowerGain = value;
            }
        }

        [Obsolete]
        public string GetAPPVersion()
        {
            var activity = MainActivity.Instance;
            return activity.PackageManager.GetPackageInfo(activity.PackageName, 0).VersionName;
        }
        public string GetSDKVersion()
        {
            if (GetAsReaderStatus() == false)
            {
                return "";
            }
            else
            {
                return AsReaderP252BManager.Version;
            }
        }
        public string GetFirmwareVersion()
        {
            if (GetAsReaderStatus() == false)
            {
                return "";
            }
            else
            {
                return mReader.FirmwareVersion;
            }
        }
        public string GetRFModuleVersion()
        {
            if (GetAsReaderStatus() == false)
            {
                return "";
            }
            else
            {
                return mReader.RFModuleVersion;
            }
        }
        public string GetRegion()
        {
            if (GetAsReaderStatus() == false)
            {
                return "";
            }
            else
            {
                return mReader.Region;
            }
        }
        public string GetSerialNumber()
        {
            if (GetAsReaderStatus() == false)
            {
                return "";
            }
            else
            {
                return mReader.SerialNumber;
            }
        } 
        public int GetBatteryStatus()
        {
            if (GetAsReaderStatus() == false)
            {
                return 0;
            }
            else
            {
                return mReader.BatteryStatus;
            }
        }
        public void StartDecode()
        {
            if (GetAsReaderStatus() == true)
            {
                mReader.StartDecode();
            }
        }
        public void StopDecode()
        {
            if (GetAsReaderStatus() == true)
            {
                mReader.StopDecode();
            }
        }
        public void Inventory()
        {
            if (GetAsReaderStatus() == true)
            {
                mReader.Inventory();
            }
        }
        public void Stop()
        {
            if (GetAsReaderStatus() == true)
            {
                mReader.Stop();
            }
        }
        public ArrayList GetPowerGainRange()
        {
            ArrayList mList = new ArrayList();
            if (GetAsReaderStatus() == true)
            {
                AsReaderP252BPowerRange powerRange = mReader.PowerGainRange;
                int min = powerRange.Min / 10;
                max = powerRange.Max / 10;

                for (int i = min; i <= max; i += 1)
                {
                    mList.Add(i.ToString());
                }
            }
            return mList;
        }
        public int GetPowerRangeMax()
        {
            return max;
        }
        public void SetContinuousMode(bool enabled)
        {
            if (GetAsReaderStatus() == true)
            {
                mReader.ContinuousMode = enabled;
            }
        }
        public void Destroy()
        {
            if (GetAsReaderStatus() == true)
            {
                AsReaderP252BManager.OnDestroy();
                if (mDevice != null)
                {
                    mDevice.Destroy();
                    mDevice = null;
                }
            }
        } 
        public bool GetAsReaderStatus()
        {
            if (mReader != null && mDevice != null && mDevice.State == AsReaderP252BConnectionState.Connected && isConnect)
            {
                return true;
            }
            else
            {
                return false;
            }
        } 
        public string GetAsReader251GSDKDLL()
        {
            return AsReaderP252BSDKDLL.DLLVersion();
        }
    }
}

